# Summary

* [前言](README.md)
* [Python代码规范](/codeSpecification/codeSpecification_Preface.md)
  - [简明概述](/codeSpecification/codeSpecification_first.md)
  - [注释](/codeSpecification/codeSpecification_second.md)
  - [命名规范](/codeSpecification/codeSpecification_third.md)
* [第一个Python程序](/python1/Preface.md)
  - [Python 简介](/python1/Introduction.md)
  - [Python 的安装](/python1/Installation.md)
  - [第一个 Python 程序](/python1/The_first_procedure.md)
  - [集成开发环境（IDE）: PyCharm](/python1/IDE.md)
* [基本数据类型和变量](/python2/Preface.md)
  - [Python 语法的简要说明](/python2/Grammar.md)
  - [Python 的基本数据类型](/python2/Type_of_data.md)
  - [基本数据类型转换](/python2/Type_conversion.md)
  - [Python 中的变量](/python2/Variable.md)
* [List 和 Tuple](/python3/Preface.md)
  - [List（列表）](/python3/List.md)
  - [tuple（元组）](/python3/tuple.md)
* [ Dict 和 Set](/python4/Preface.md)
  - [字典(Dictionary)](/python4/Dict.md)
  - [set](/python4/Set.md)
* [条件语句和循环语句](/python5/Preface.md)
  - [条件语句](/python5/If.md)
  - [循环语句](/python5/Cycle.md)
  - [条件语句和循环语句综合实例](/python5/Example.md)
* [函数](/python6/Preface.md)
  - [Python 自定义函数的基本步骤](/python6/1.md)
  - [函数传值问题](/python6/2.md)
  - [函数返回值](/python6/3.md)
  - [函数的参数](/python6/4.md)
  - [匿名函数](/python6/5.md)
* [迭代器和生成器](/python7/Preface.md)
  - [迭代](/python7/1.md)
  - [Python 迭代器](/python7/2.md)
  - [lsit 生成式（列表生成式）](/python7/3.md)
  - [生成器](/python7/4.md)
  - [迭代器和生成器综合例子](/python7/5.md)
* [模块与包](/python8/Preface.md)
  - [Python 模块简介](/python8/1.md)
  - [模块的使用](/python8/2.md)
  - [主模块和非主模块](/python8/3.md)
  - [包](/python8/4.md)
  - [作用域](/python8/5.md)
* [面向对象](/python9/Preface.md)
  - [面向对象的概念](/python9/1.md)
  - [类](/python9/2.md)
  - [类的属性](/python9/3.md)
  - [类的方法](/python9/4.md)
  - [类的继承](/python9/5.md)
  - [类的多态](/python9/6.md)
* [Python 的 Magic Method](/python10/Preface.md)
  - [Python 的 Magic Method](/python10/1.md)
  - [构造(`__new__`)和初始化(`__init__`)](/python10/2.md)
  - [属性的访问控制](/python10/3.md)
  - [对象的描述器](/python10/4.md)
  - [自定义容器（Container）](/python10/5.md)
  - [运算符相关的魔术方法](/python10/6.md)
* [枚举类](/python11/Preface.md)
  - [枚举类的使用](/python11/1.md)
  - [Enum 的源码](/python11/2.md)
  - [自定义类型的枚举](/python11/3.md)
  - [枚举的比较](/python11/4.md)
* [元类](/python12/Preface.md)
  - [Python 中类也是对象](/python12/1.md)
  - [使用 `type()` 动态创建类](/python12/2.md)
  - [什么是元类](/python12/3.md)
  - [自定义元类](/python12/4.md)
  - [使用元类](/python12/5.md)
* [线程与进程](/python13/Preface.md)
  - [线程与进程](/python13/1.md)
  - [多线程编程](/python13/2.md)
  - [进程](/python13/3.md)
* [一步一步了解正则表达式](/python14/Preface.md)
    - [初识 Python 正则表达式](/python14/1.md)
    - [字符集](/python14/2.md)
    - [数量词](/python14/3.md)
    - [边界匹配符和组](/python14/4.md)
    - [re.sub](/python14/5.md)
    - [re.match 和 re.search](/python14/6.md)
